# -*- coding:Utf-8 -*-
# ~ powered by GODJonez's popuplib module ~




########################################################### INFO ###########################################################

"""
    ■ simplemenulib function

        ▪ Global function, type can be 'menu', 'vote' or 'list'
            • type(<name>)                                                  // get the type of a simplemenulib construction, can return ['menu', 'vote', 'list']
            • active(<userid>)                                              // get information from a menu or a vote that player is wiewing, type can be 'menu', 'vote' or 'list'
            • find(<name>, [type])                                          // return the instance of a menu or a vote, type can be 'menu', 'vote' or 'list'
            • exists(<name>, [type])                                        // check if a menu or a vote exists, type can be 'menu', 'vote' or 'list'
            • delete(<name>, [type])                                        // delete an existing menu or vote, type can be 'menu', 'vote' or 'list'
            • close(<users>, <name>, [page], [type])                        // close a menu that player is viewing, type can be 'menu', 'vote' or 'list'
            • unsend(<users>, <name>, [page], [type])                       // unsend a menu that player is wiewing, type can be 'menu', 'vote' or 'list'
            • isqueued(<userid>, <name>, [page], [type])                    // find if a page of a menu or vote is queued to a player, type can be 'menu' or 'vote'
            • addlist(<list name>, <name>, [type])                          // add a menu and/or a vote in a list for a global deleting, type can be 'menu', 'vote' or 'list'
            • getlist(<list name>)                                          // get name of all menu and/or vote stored in the list
            • dellist(<list name>)                                          // delete all menu and/or vote stored in the list

        ▪ Menu function
            • menu(<menuname>)                                              // create a menu
            • send(<users>, <menuname>, [page], [prio])                     // send a menu to a player(s)

        ▪ Vote function
            • vote(<votename>)                                              // create a vote
            • stop(<votename>)                                              // stop a vote
            • end(<votename>)                                               // end a vote
            • disqualify(<votename>, <users>)                               // disqualify a (group of) player from a vote
            • submit(<votename>, [users], [time], [showhudstat], [prio])    // submit a vote to a (group of) player
            • info(<votename>, [attrib])                                    // get info from a vote (all if 'attrib' is not given)
            'attrib' can be "showhud", "isrunning", "timeleft", "votecount", "participents", "winninganswer", "winningplayers", "answersvote", "playersvote"

        ▪ List function
            • list(<listname>, [listitem])                                  // create a list (top10 style)
            • display(<users>, [page], [prio])                              // dispaly a list (top10 style)


    ■ simplemenulib class

        ● SimplemenulibBase (mutual methodes for menu, vote and list construction)
            ▪ Methode
                • build()
                • delete()
                • pagecount()
                • itemcount()
                • addReturnKey()
                • delReturnKey()
                • pageexists(<page>)
                • pageview(<userid>)
                • addlist(<listname>)
                • loadlang(<filepath>)
                • close(<users>, [page])
                • unsend(<users>, [page])
                • timeout([mode], [time])
                • popupreturn(<popupname>)
                • isqueued(<userid>, [page])
                • itempage(<item>, [withvalue])
                • itemvalue(<item>, [pageindex])
                • itemexists(<item>, [withvalue], [pageindex])
                • getModifiedItem(<item>, [withvalue], [pageindex])
                • simplemenureturn(<simplemenuname>, [page], [type])
                • subpopupmenu(<item>, <name>, [withvalue], [pageindex])
                • subsimplemenu(<item>, <name>, [page], [type], [withvalue], [pageindex])

        ● SimplemenulibMenu
            ▪ Methode
                • send(<users>, [page], [prio])
                • title(<title>, [options], [showpage])
                • delchoice(<choice>, [withvalue], [pageindex])
                • setchoice(<choice>, [newvalue], [withvalue], [pageindex])
                • addchoice(<choice>, [value], [options], [inserttag], [underline])
                • inschoice(<choice>, <newchoice>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])
                • modchoice(<choice>, <newchoice>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])

            ▪ Attribute
                → blockselect = "block"     // block or definition called when player select a choice from a menu
                → blockselectic = "block"   // block or definition called when player select an invalid choice from a menu
                → blockselectnc = "block"   // block or definition called when player select a navigation choice from a menu

        ● SimplemenulibVote
            ▪ Methode
                • end()
                • stop()
                • disqualify(<users>)
                • question(<question>, [options], [showpage])
                • delanswer(<answer>, [withvalue], [pageindex])
                • submit([users], [time], [page], [showhudstat], [prio])
                • setanswer(<answer>, [newvalue], [withvalue], [pageindex])
                • addanswer(<answer>, [value], [options], [inserttag], [underline])
                • insanswer(<answer>, <newanswer>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])
                • modanswer(<answer>, <newanswer>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])

            ▪ Attribute
                → blockendvote = "block"    // block or definition called when vote is ending
                → blocksubmit = "block"     // block or definition called when player select an answer from  a vote
                → blocksubmitic = "block"   // block or definition called when player select an invalid choice from a vote
                → blocksubmitnc = "block"   // block or definition called when player select a navigation choice from a vote

            ▪ Get Attribute ( myVote["myAttribute"] )
                - "showhud"                 // get if stats is showed in hud of players
                - "isrunning"               // get if vote is running
                - "timeleft"                // get time left before end of vote
                - "votecount"               // get count of vote submited in vote
                - "participents"            // get count of participents
                - "winninganswer"           // get answer, value, count and modified answer info from winning answer
                - "winningplayers"          // get userid list of players that have voted for winning answer
                - "answersvote"             // get answer, value, count and modified answer info from all voted answers
                - "playersvote"             // get userid dictionnary with answer, value, count and modified answer

        ● SimplemenulibList
            ▪ Methode
                • display(<users>, [page], [prio])
                • title(<title>, [options], [showpage])
                • delitem(<item>, [withvalue], [pageindex])
                • setitem(<item>, [newvalue], [withvalue], [pageindex])
                • additem(<item>, [value], [options], [inserttag], [underline])
                • insitem(<item>, <newitem>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])
                • moditem(<item>, <newitem>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])

            ▪ Attribute
                → blocklist = "block"         // block or definition called when player select an item from a list
                → blocklistic = "block"       // block or definition called when player select an invalid choice from a list
                → blocklistnc = "block"       // block or definition called when player select a navigation choice from a list
"""

########################################################### INFO ###########################################################




""" Modules importation """
import psyco, random, es, langlib, popuplib, playerlib, gamethread
psyco.full()

""" Check game compatibility """
class SimplemenulibGameError(Exception): pass
if es.getGameName() not in ("cstrike", "dod", "tf", "left4dead", "left4dead2"): raise SimplemenulibGameError, 'Simplemenulib: game "%s" is not supported' % es.getgame()

""" Module informations """
libs = es.AddonInfo()
libs.author = "DoCky"
libs.version = "2.113p"
libs.name = "SimpleMenuLib"
libs.basename = "simplemenu"
libs.url = "http://addons.eventscripts.com/addons/view/Simplemenu"
libs.description = "Provides menu, vote and list handling for Source games"
es.ServerVar(libs.name, libs.version, "Created by DoCky -").makepublic()


""" globals variables """
simplemenupath = es.ServerVar("eventscripts_gamedir")
simplemenucast = {}
simplemenumenu = {}
simplemenuvote = {}
simplemenulist = {}
simplemenuuser = {}
simplemenumaxi = 7




#####################################
# SIMPLEMENULIB TOOLS

def _getType(name):
    """ get type of construction """
    name, type = str(name), []
    if popuplib.exists(name): type.append("popup")
    if simplemenumenu.has_key(name): type.append("menu")
    if simplemenuvote.has_key(name): type.append("vote")
    if simplemenulist.has_key(name): type.append("list")
    return type

def _getPage(item):
    """ get count of page """
    if item < 2: page = 1
    else:
        page = item / simplemenumaxi
        if item % simplemenumaxi > 1: page += 1
    return page

def _getItem(index, page, total):
    """ get count of item for a page """
    if index < page: item = simplemenumaxi
    else: item = total - (index - 1) * simplemenumaxi
    return item

def _getLine(line, options = {}, inserttag = ""):
    """ get formated line """
    if isinstance(line, str): return _getOption(line, options, inserttag)
    elif isinstance(line, dict):
        lines = {}
        for lang, string in line.items(): lines[lang] = _getOption(string, options, inserttag)
        return lines
    else: return None

def _getMenu(line, index, underline = False, options = {}, inserttag = ""):
    """ get menu formated line """
    if isinstance(line, str):
        string = _getOption(line, options, inserttag)
        return "%s%s. %s" % ("->" if underline else "", index, string)
    elif isinstance(line, dict):
        menu = {}
        if underline:
            for lang, string in line.items(): menu[lang] = "->%s. %s" % (index, _getOption(string, options, inserttag))
        else:
            for lang, string in line.items(): menu[lang] = "%s. %s" % (index, _getOption(string, options, inserttag))
        return menu
    else: return None

def _getOption(string, options = {}, inserttag = ""):
    """ replace options and tag from a string """
    if not options and inserttag: string = "%s %s" % (inserttag, string)
    else:
        for item, value in options.items():
            if inserttag: string = "%s %s" % (inserttag, string.replace(item, str(value)))
            else: string = string.replace(item, str(value))
    return string




#####################################
# SIMPLEMENULIB BUILDER

class SimplemenulibBuilder(object):
    """
        ● SimplemenulibBuilder (internals menu, vote and list builder)
            ▪ Methode
                • _title_()
                • _build_()
                • _delete_()
                • _item_(<item>)
                • _valid_(<item>)
                • _addReturnKey_()
                • _delReturnKey_()
                • _count_([entity])
                • _page_(<item>, [withvalue])
                • _exists_([entity], [value])
                • _getValidUseridList_(<users>)
                • _index_(<item>, [withvalue], [pageindex])
                • _delitem_(<item>, <withvalue>, <pageindex>)
                • _submenu_(<userid>, <name>, <page>, <type>)
                • _getModifiedItem_(<item>, <withvalue>, <pageindex>)
                • _setitem_(<item>, <newvalue>, <withvalue>, <pageindex>)
                • _additem_(<item>, <value>, <options>, <inserttag>, <underline>)
                • _insitem_(<item>, <newitem>, <value>, <options>, <inserttag>, <underline>, <withvalue>, <pageindex>)
                • _moditem_(<item>, <newitem>, <value>, <options>, <inserttag>, <underline>, <withvalue>, <pageindex>)
    """

    def __init__(self, type, name):
        self.type = type
        self.name = name
        self.i_line = []
        self.i_page = []
        self.i_choice = {}
        self.i_navfunc = {}
        self.i_title = None
        self.i_showpage = True
        self.i_loadlang = False
        self.i_multilang = None
        self.i_construct = False
        self.i_addReturnKey = False

        # default supported languages
        self.i_menulang = {
            "_smlib_title" : {"en" : "Simplemenu", "fr" : "Simplemenu"},
            "_smlib_next" : {"en" : "Next", "fr" : "Suivant"},
            "_smlib_back" : {"en" : "Back", "fr" : "Retour"},
            "_smlib_exit" : {"en" : "Quit", "fr" : "Sortir"},
            "_smlib_hudrun" : {
                "en" : "$question\nTime : $seconds - Vote : $hasvoted/$participents",
                "fr" : "$question\nTemps : $seconds - Vote : $hasvoted/$participents"},
            "_smlib_hudany" : {
                "en" : "$question\nTime : illimited - Vote : $hasvoted/$participents",
                "fr" : "$question\nTemps : illimité - Vote : $hasvoted/$participents"},
            "_smlib_hudend" : {
                "en" : "The question was : $question\nThe answer is : $answer",
                "fr" : "La question était : $question\nLa réponse est : $answer"},
            "_smlib_hudadd" : {
                "en" : "$position. [$votes] $answer",
                "fr" : "$position. [$votes] $answer"}}

    def __selectConvar(self, userid, index, choice, value, page):
        """ set server variables for ESS scripts """
        if self.type is "menu":
            es.set("_menu_userid", userid)
            es.set("_menu_index", index)
            es.set("_menu_choice", choice)
            es.set("_menu_value", value)
            es.set("_menu_name", self.name)
            es.set("_menu_page", page)

        elif self.type is "vote":
            es.set("_vote_userid", userid)
            es.set("_vote_index", index)
            es.set("_vote_answer", choice)
            es.set("_vote_value", value)
            es.set("_vote_name", self.name)
            es.set("_vote_page", page)

        elif self.type is "list":
            es.set("_list_userid", userid)
            es.set("_list_index", index)
            es.set("_list_answer", choice)
            es.set("_list_value", value)
            es.set("_list_name", self.name)
            es.set("_list_page", page)

    def __selectError(self, function, typeselect):
        """ internal error massage sended when calling of function failed """
        es.dbgmsg(0, "Simplemenulib found invalid function '%s' for %s %s" % (function if isinstance(function, str) else function.__name__, self.type, self.name))
        if typeselect in ("blockselect", "blocksubmit", "blocklist"): es.dbgmsg(0, "Simplemenulib callback function '%s' must accept six parameters" % typeselect)
        else: es.dbgmsg(0, "Simplemenulib callback function '%s' must accept four parameters" % typeselect)

    def __selectBlock(self, userid, index, popup):
        """ internal called function when player making choice """
        if self.type is "menu":
            simplemenuuser[userid].remPopup(self)
            page = self.i_page.index(popup) + 1
            if self.i_choice[popup].has_key(index):
                choice, value, submenu = self.i_choice[popup][index]
                if submenu:
                    if isinstance(submenu, tuple):
                        name, page, type = submenu
                        self._submenu_(userid, name, page, type)
                    elif isinstance(submenu, str): popuplib.send(submenu, userid)

                if callable(self.blockselect):
                    try: self.blockselect(userid, index, choice, value, self.name, page)
                    except TypeError: self.__selectError(self.blockselect, "blockselect")
                elif es.exists("block", self.blockselect):
                    self.__selectConvar(userid, index, choice, value, page)
                    es.doblock(self.blockselect)

            elif self.i_navfunc[popup].has_key(index):
                submenu = self.i_navfunc[popup][index]
                if submenu:
                    if isinstance(submenu, tuple):
                        name, page, type = submenu
                        self._submenu_(userid, name, page, type)
                    elif isinstance(submenu, str):
                        simplemenuuser[userid].setPopup(self, True)
                        popuplib.send(submenu, userid)

                if callable(self.blockselectnc):
                    try: self.blockselectnc(userid, index, self.name, page)
                    except TypeError: self.__selectError(self.blockselectnc, "blockselectnc")
                elif es.exists("block", self.blockselectnc):
                    self.__selectConvar(userid, index, index, index, page)
                    es.doblock(self.blockselectnc)

            elif callable(self.blockselectic):
                try: self.blockselectic(userid, index, self.name, page)
                except TypeError: self.__selectError(self.blockselectic, "blockselectic")
            elif es.exists("block", self.blockselectic):
                self.__selectConvar(userid, index, index, index, page)
                es.doblock(self.blockselectic)

        elif self.type is "vote":
            if self.voterun:
                page = self.i_page.index(popup) + 1
                if self.i_choice[popup].has_key(index):
                    answer, value, submenu = self.i_choice[popup][index]
                    self.voteadd += 1
                    vote = self._voteIsRecorded(answer, value)
                    if vote is not None: vote + userid
                    else:
                        vote = VoteAnswer(answer, value, self._getModifiedItem_(answer, value, ()))
                        vote + userid
                        self.votecast.append(vote)
                    self.voteplayer[userid] = vote
                    self.votecast.sort(reverse = True)

                    if callable(self.blocksubmit):
                        try: self.blocksubmit(userid, index, answer, value, self.name, page)
                        except TypeError: self.__selectError(self.blocksubmit, "blocksubmit")
                    elif es.exists("block", self.blocksubmit):
                        self.__selectConvar(userid, index, answer, value, page)
                        es.doblock(self.blocksubmit)
                    if self.voteadd < len(self.voteplayer): self._hud()
                    else: self.end()

                    simplemenuuser[userid].remPopup(self, False)
                    if submenu:
                        if isinstance(submenu, tuple):
                            name, page, type = submenu
                            self._submenu_(userid, name, page, type)
                        elif isinstance(submenu, str): popuplib.send(submenu, userid)

                elif self.i_navfunc[popup].has_key(index):
                    simplemenuuser[userid].remPopup(self, False)
                    submenu = self.i_navfunc[popup][index]
                    if submenu:
                        if isinstance(submenu, tuple):
                            name, page, type = submenu
                            self._submenu_(userid, name, page, type)
                        elif isinstance(submenu, str):
                            simplemenuuser[userid].setPopup(self, True)
                            popuplib.send(submenu, userid)

                    if callable(self.blocksubmitnc):
                        try: self.blocksubmitnc(userid, index, self.name, page)
                        except TypeError: self.__selectError(self.blocksubmitnc, "blocksubmitnc")
                    elif es.exists("block", self.blocksubmitnc):
                        self.__selectConvar(userid, index, index, index, page)
                        es.doblock(self.blocksubmitnc)

                elif callable(self.blocksubmitic):
                    simplemenuuser[userid].remPopup(self, False)
                    try: self.blocksubmitic(userid, index, self.name, page)
                    except TypeError: self.__selectError(self.blocksubmitic, "blocksubmitic")
                elif es.exists("block", self.blocksubmitic):
                    simplemenuuser[userid].remPopup(self, False)
                    self.__selectConvar(userid, index, index, index, page)
                    es.doblock(self.blocksubmitic)

        elif self.type is "list":
            simplemenuuser[userid].remPopup(self)
            page = self.i_page.index(popup) + 1
            if self.i_choice[popup].has_key(index):
                choice, value, submenu = self.i_choice[popup][index]
                if submenu:
                    if isinstance(submenu, tuple):
                        name, page, type = submenu
                        self._submenu_(userid, name, page, type)
                    elif isinstance(submenu, str): popuplib.send(submenu, userid)

                if callable(self.blocklist):
                    try: self.blocklist(userid, index, choice, value, self.name, page)
                    except TypeError: self.__selectError(self.blocklist, "blocklist")
                elif es.exists("block", self.blocklist):
                    self.__selectConvar(userid, index, choice, value, page)
                    es.doblock(self.blocklist)

            elif self.i_navfunc[popup].has_key(index):
                submenu = self.i_navfunc[popup][index]
                if submenu:
                    if isinstance(submenu, tuple):
                        name, page, type = submenu
                        self._submenu_(userid, name, page, type)
                    elif isinstance(submenu, str):
                        simplemenuuser[userid].setPopup(self, True)
                        popuplib.send(submenu, userid)

                if callable(self.blocklistnc):
                    try: self.blocklistnc(userid, index, self.name, page)
                    except TypeError: self.__selectError(self.blocklistnc, "blocklistnc")
                elif es.exists("block", self.blocklistnc):
                    self.__selectConvar(userid, index, index, index, page)
                    es.doblock(self.blocklistnc)

            elif callable(self.blocklistnc):
                try: self.blocklistnc(userid, index, self.name, page)
                except TypeError: self.__selectError(self.blocklistnc, "blocklistnc")
            elif es.exists("block", self.blocklistnc):
                self.__selectConvar(userid, index, index, index, page)
                es.doblock(self.blocklistnc)

    def _submenu_(self, userid, name, page, type):
        if type is None:
            try: simplemenumenu[name].send(userid, page, True)
            except KeyError:
                try: simplemenuvote[name].submit(userid, page = page, prio = True)
                except KeyError:
                    try: simplemenulist[name].display(userid, page, True)
                    except KeyError: es.dbgmsg(0, "Simplemenulib: function subsimplemenu for %s %s  cannot find menu, vote or list %s" % (self.type, self.name, name))
        elif type is "menu":
            try: simplemenumenu[name].send(userid, page, True)
            except KeyError: es.dbgmsg(0, "Simplemenulib: function subsimplemenu for %s %s  cannot find menu %s" % (self.type, self.name, name))
        elif type is "vote":
            try: simplemenuvote[name].submit(userid, page = page, prio = True)
            except KeyError: es.dbgmsg(0, "Simplemenulib: function subsimplemenu for %s %s  cannot find vote %s" % (self.type, self.name, name))
        elif type is "list":
            try: simplemenulist[name].display(userid, page, True)
            except KeyError: es.dbgmsg(0, "Simplemenulib: function subsimplemenu for %s %s  cannot find list %s" % (self.type, self.name, name))

    def _delete_(self):
        """ internal deleting page(s) of menu/vote/list """
        for menu in self.i_page:
            if popuplib.exists(menu): popuplib._delete(menu)

    def _valid_(self, item):
        """ check if an item is valid for the type of construction """
        if self.i_multilang is None:
            if isinstance(item, str): self.i_multilang = False
            elif isinstance(item, dict): self.i_multilang = True
            else: raise TypeError("Simplemenulib: cannot work with item '%s' for %s, this is not a multilangual %s" % (self.i_title, self.name, self.type))
        elif self.i_multilang is True and isinstance(item, str):
            raise TypeError("Simplemenulib: cannot work with item '%s' for %s, the argument must be a string or a dictionnary" % (item, self.name))
        elif self.i_multilang is False and isinstance(item, dict):
            raise TypeError("Simplemenulib: cannot work with item '%s' for %s, this is a multilangual %s" % (self.i_title, self.name, self.type))
        return True


    def _count_(self, entity = "page"):
        """ get count of specified entity """
        if entity is "page":
            if self.i_construct: return len(self.i_page)
            else: return _getPage(len(self.i_line))

    def _index_(self, item, withvalue = None, pageindex = ()):
        """ get index item from list """
        for line in self.i_line:
            if line[0] == item:
                if withvalue is None and not pageindex: return self.i_line.index(line)
                elif withvalue == line[1]: return self.i_line.index(line)
                elif pageindex:
                    try:
                        nbrItem = len(pageindex)
                        if nbrItem == 2:
                            page, index = pageindex
                            if self._exists_(value = page):
                                idxList = (page - 1) * simplemenumaxi + index
                                if idxList > 0 and idxList <= len(self.i_line): return self.i_line.index(line)
                                return -1
                        raise ValueError("Simplemenulib: cannot get index for item '%s', sequence must contains 2 arguments at all" % item)
                    except TypeError: "Simplemenulib: cannot get index for item '%s', paramter 'pageindex' must be a sequence" % item
        return -1

    def _exists_(self, entity = "page", value = None):
        """ get if a specified entity is existing """
        if entity is "page":
            try:
                page = int(value)
                if page > 0 and page <= self._count_(): return True
                return False
            except ValueError: "Simplemenulib: page '%s' for %s %s must be numerical or a numerical string" % (value, self.type, self.name)

        elif entity is "isValidId":
            try:
                userid = int(value)
                if not es.exists("userid", userid) or es.isbot(userid): return False
                return True
            except ValueError: "Simplemenulib: userid '%s' for %s %s must be numerical or a numerical string" % (value, self.type, self.name)

    def _item_(self, item):
        """ get string if menu or vote has loaded file for language """
        if self.i_loadlang and isinstance(item, str):
            try: return self.i_menulang[item]
            except KeyError: return item
        else: return item

    def _page_(self, item, withvalue):
        """ get page of an item """
        if self._valid_(item):
            idxItem = self._index_(item, withvalue) + 1
            if idxItem: return _getPage(idxItem)
            else: return 0

    def _title_(self):
        """ set title for all page """
        if self.i_title is None:
            if self.i_multilang: self.i_title = self.i_menulang["_smlib_title"]
            else:
                self.i_multilang = False
                self.i_title = self.i_menulang["_smlib_title"][self.defaultlang]
        if self._valid_(self.i_title):
            totalPage = len(self.i_page)
            currentPage = 0
            for popup in self.i_page:
                currentPage += 1
                if not self.i_multilang:
                    if self.i_showpage: popuplib.find(popup).modline(1, "%s        %s/%s" % (self.i_title, currentPage, totalPage))
                    else: popuplib.find(popup).modline(1, self.i_title)
                else:
                    title = {}
                    for lang, string in self.i_title.items():
                        if self.i_showpage: title[lang] = "%s        %s/%s" % (string, currentPage, totalPage)
                        else: title[lang] = string
                    popuplib.find(popup).modlineAll(1, title)

    def _build_(self):
        """ build menu for first time """
        totalItem = len(self.i_line)
        totalPage = _getPage(totalItem)
        currentPage = 0
        indexList = 0

        for currentPage in xrange(1, totalPage + 1):
            menuName = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage)
            self.i_page.append(menuName)
            self.i_choice[menuName] = {}
            self.i_navfunc[menuName] = {}
            popup = popuplib.create(menuName)
            popup.addline(" ")

            if self.type is "list":
                for indexItem in xrange(1, _getItem(currentPage, totalPage, totalItem) + 1):
                    infItem, infValue, infOption, infTag, infUnder, infSubmenu = self.i_line[indexList]
                    popup.addline(_getMenu(infItem, indexList + 1, infUnder, infOption, infTag))
                    self.i_line[indexList][6:] = menuName, currentPage, indexItem, indexList
                    self.i_choice[menuName][indexItem] = (infItem, infValue, infSubmenu)
                    indexList += 1

                if currentPage < totalPage:
                    self.i_navfunc[menuName][8] = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage + 1)
                    if self.i_multilang: popup.addline(_getMenu(self.i_menulang["_smlib_next"], 8, True))
                    else: popup.addline(_getMenu(self.i_menulang["_smlib_next"][self.defaultlang], 8, True))
                if currentPage == 1:
                    if self.i_addReturnKey:
                        self.i_navfunc[menuName][9] = "" if self.i_addReturnKey is True else self.i_addReturnKey
                        if self.i_multilang: popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9, True))
                        else: popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9, True))
                else:
                    self.i_navfunc[menuName][9] = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage - 1)
                    if self.i_multilang: popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9, True))
                    else: popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9, True))

            else:
                for indexItem in xrange(1, _getItem(currentPage, totalPage, totalItem) + 1):
                    infItem, infValue, infOption, infTag, infUnder, infSubmenu = self.i_line[indexList]
                    popup.addline(_getMenu(infItem, indexItem, infUnder, infOption, infTag))
                    self.i_line[indexList][6:] = menuName, currentPage, indexItem, indexList
                    self.i_choice[menuName][indexItem] = (infItem, infValue, infSubmenu)
                    indexList += 1

                if currentPage < totalPage:
                    self.i_navfunc[menuName][8] = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage + 1)
                    if self.i_multilang: popup.addline(_getMenu(self.i_menulang["_smlib_next"], 8))
                    else: popup.addline(_getMenu(self.i_menulang["_smlib_next"][self.defaultlang], 8))
                if currentPage == 1:
                    if self.i_addReturnKey:
                        self.i_navfunc[menuName][9] = "" if self.i_addReturnKey is True else self.i_addReturnKey
                        if self.i_multilang: popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9))
                        else: popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9))
                else:
                    self.i_navfunc[menuName][9] = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage - 1)
                    if self.i_multilang: popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9))
                    else: popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9))

            self.i_navfunc[menuName][10] = ""
            if self.i_multilang: popup.addline(_getMenu(self.i_menulang["_smlib_exit"], 0))
            else: popup.addline(_getMenu(self.i_menulang["_smlib_exit"][self.defaultlang], 0))

            popup.menuselect = self.__selectBlock
            if self.i_timeout: popup.timeout(self.i_timeout[0], self.i_timeout[1])
        self._title_()
        self.i_construct = True

    def _additem_(self, item, value, options, inserttag, underline):
        """ add an item """
        if self._valid_(item):
            if not self.i_construct: self.i_line.append([item, value, options, inserttag, underline, ""])
            else:
                indexList = len(self.i_line) - 1
                if indexList < 0:
                    menuName = self.i_page[0]
                    self.i_choice[menuName][1] = (item, value, "")
                    self.i_line.append([item, value, options, inserttag, underline, "", menuName, 1, 1, 0])
                    popuplib.find(menuName).insline(2, _getMenu(item, 1, underline, options, inserttag))
                else:

                    lastItem, lastValue, lastOption, lastTag, lastUnder, lastSubmenu, lastName, lastPage, lastIndex, lastList = self.i_line[indexList]
                    if lastIndex == 8:
                        if self.i_multilang: popuplib.find(lastName).modlineAll(9, _getMenu(self.i_menulang["_smlib_next"], 8))
                        else: popuplib.find(lastName).modline(9, _getMenu(self.i_menulang["_smlib_next"], 8))
                        del self.i_choice[lastName][8]

                        currentPage = lastPage + 1
                        menuName = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage)
                        self.i_navfunc[lastName][8] = menuName
                        self.i_line[indexList][6:9] = menuName, currentPage, 1
                        self.i_choice[menuName] = {1 : (lastItem, lastValue, lastSubmenu)}
                        indexList += 1

                        self.i_page.append(menuName)
                        self.i_line.append([item, value, options, inserttag, underline, "", menuName, currentPage, 2, indexList])
                        self.i_choice[menuName][2] = (item, value, "")
                        self.i_navfunc[menuName] = {9 : lastName, 10 : ""}

                        popup = popuplib.create(menuName)
                        popup.addline(" ")

                        if self.type is "list":
                            popup.addline(_getMenu(lastItem, lastList + 1, lastUnder, lastOption, lastTag))
                            popup.addline(_getMenu(item, lastList + 2, underline, options, inserttag))
                            if self.i_multilang:
                                popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9, True))
                                popup.addline(_getMenu(self.i_menulang["_smlib_exit"], 0))
                            else:
                                popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9, True))
                                popup.addline(_getMenu(self.i_menulang["_smlib_exit"][self.defaultlang], 0))

                        else:
                            popup.addline(_getMenu(lastItem, 1, lastUnder, lastOption, lastTag))
                            popup.addline(_getMenu(item, 2, underline, options, inserttag))
                            if self.i_multilang:
                                popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9))
                                popup.addline(_getMenu(self.i_menulang["_smlib_exit"], 0))
                            else:
                                popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9))
                                popup.addline(_getMenu(self.i_menulang["_smlib_exit"][self.defaultlang], 0))
                        popup.menuselect = self.__selectBlock
                        self._title_()

                    else:
                        infIndex, infList = lastIndex + 1, lastList + 1
                        self.i_choice[lastName][infIndex] = (item, value)
                        self.i_line.append([item, value, options, inserttag, underline, "", lastName, lastPage, infIndex, infList])
                        if self.type is "list": popuplib.find(lastName).insline(infIndex + 1, _getMenu(item, lastList + 2, underline, options, inserttag))
                        else: popuplib.find(lastName).insline(infIndex + 1, _getMenu(item, infIndex, underline, options, inserttag))

    def _delitem_(self, item, withvalue, pageindex):
        """ delete an item """
        if self._valid_(item):
            index = self._index_(item, withvalue, pageindex)
            if index < 0: raise ValueError("Simplemenulib: cannot delete item '%s' for %s %s, it does not exists" % (item, self.type, self.name))
            elif not self.i_construct: del self.i_line[index]
            else:

                delItem, delValue, delOption, delTag, delUnder, delSubmenu, delName, delPage, delIndex, delList = self.i_line[index]
                del self.i_line[index]
                totalItem = len(self.i_line)
                if not totalItem:
                    popuplib.find(delName).dellineAll(2)
                    self.i_choice[delName].clear()

                else:
                    if delPage == 1: currentPage = delPage
                    else: currentPage = delPage if delIndex > 2 else delPage - 1
                    indexList = (currentPage - 1) * simplemenumaxi
                    totalPage = _getPage(totalItem)

                    for currentPage in xrange(currentPage, totalPage + 1):
                        menuName = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage)
                        self.i_choice[menuName].clear()
                        popup = popuplib.find(menuName)

                        for indexItem in xrange(1, _getItem(currentPage, totalPage, totalItem) + 1):
                            infItem, infValue, infOption, infTag, infUnder, infSubmenu, infName, infPage, infIndex, infList = self.i_line[indexList]
                            self.i_choice[menuName][indexItem] = infItem, infValue, infSubmenu
                            self.i_line[indexList][6:] = menuName, currentPage, indexItem, indexList
                            if self.type is "list":
                                if self.i_multilang: popup.modlineAll(indexItem + 1, _getMenu(infItem, indexList + 1, infUnder, infOption, infTag))
                                else: popup.modline(indexItem + 1, _getMenu(infItem, indexList + 1, infUnder, infOption, infTag))
                            elif self.i_multilang: popup.modlineAll(indexItem + 1, _getMenu(infItem, indexItem, infUnder, infOption, infTag))
                            else: popup.modline(indexItem + 1, _getMenu(infItem, indexItem, infUnder, infOption, infTag))
                            indexList += 1

                        if indexItem == 8:
                            del self.i_navfunc[menuName][8]
                            menuName = self.i_page[-1]
                            popuplib._delete(menuName)
                            del self.i_choice[menuName]
                            del self.i_navfunc[menuName]
                            self.i_page.remove(menuName)
                            self._title_()
                        elif currentPage == totalPage: popup.dellineAll(indexItem + 2)

    def _insitem_(self, item, newitem, value, options, inserttag, underline, withvalue, pageindex):
        """ insert an item after an other item """
        if self._valid_(item) and self._valid_(newitem):
            index = self._index_(item, withvalue, pageindex)
            if index < 0: raise ValueError("Simplemenulib: cannot insert new item '%s' for %s %s, item '%s' does not exists" % (newitem, self.type, self.name, item))
            else:
                self.i_line.insert(index, [newitem, value, options, inserttag, underline, ""])

                if self.i_construct:
                    totalItem = len(self.i_line)
                    totalPage = _getPage(totalItem)
                    if not index: currentPage = 1
                    else: currentPage = self.i_line[index - 1][7]
                    indexList = (currentPage - 1) * simplemenumaxi

                    for currentPage in xrange(currentPage, totalPage + 1):
                        menuName = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage)
                        if popuplib.exists(menuName):
                            popup = popuplib.find(menuName)

                            for indexItem in xrange(1, _getItem(currentPage, totalPage, totalItem) + 1):
                                infItem, infValue, infOption, infTag, infUnder, infSubmenu = self.i_line[indexList][:6]
                                self.i_line[indexList][6:] = menuName, currentPage, indexItem, indexList

                                if self.i_choice[menuName].has_key(indexItem):
                                    if self.type is "list":
                                        if self.i_multilang: popup.modlineAll(indexItem + 1, _getMenu(infItem, indexList + 1, infUnder, infOption, infTag))
                                        else: popup.modline(indexItem + 1, _getMenu(infItem, indexList + 1, infUnder, infOption, infTag))
                                    elif self.i_multilang: popup.modlineAll(indexItem + 1, _getMenu(infItem, indexItem, infUnder, infOption, infTag))
                                    else: popup.modline(indexItem + 1, _getMenu(infItem, indexItem, infUnder, infOption, infTag))
                                else:
                                    if self.type is "list": popup.insline(indexItem + 1, _getMenu(infItem, indexList + 1, infUnder, infOption, infTag))
                                    else: popup.insline(indexItem + 1, _getMenu(infItem, indexItem, infUnder, infOption, infTag))

                                self.i_choice[menuName][indexItem] = infItem, infValue, infSubmenu
                                indexList += 1

                            if currentPage < totalPage and not self.i_navfunc[menuName].has_key(8):
                                if self.i_choice[menuName].has_key(8): del self.i_choice[menuName][8]
                                self.i_navfunc[menuName][8] = "_smlib_%s_%s_%s" % (self.type, self.name, currentPage + 1)

                                if self.type is "list":
                                    if self.i_multilang: popup.modlineAll(9, _getMenu(self.i_menulang["_smlib_next"], 8, True))
                                    else: popup.modline(9, _getMenu(self.i_menulang["_smlib_next"][self.defaultlang], 8, True))
                                else:
                                    if self.i_multilang: popup.modlineAll(9, _getMenu(self.i_menulang["_smlib_next"], 8))
                                    else: popup.modline(9, _getMenu(self.i_menulang["_smlib_next"][self.defaultlang], 8))

                        else:
                            first, second = totalItem - 2, totalItem - 1
                            firItem, firValue, firOption, firTag, firUnder, firSubmenu = self.i_line[first][:6]
                            secItem, secValue, secOption, secTag, secUnder, secSubmenu = self.i_line[second][:6]

                            self.i_page.append(menuName)
                            self.i_line[first][6:] = menuName, currentPage, 1, first
                            self.i_line[second][6:] = menuName, currentPage, 2, second
                            self.i_choice[menuName] = {1 : (firItem, firValue, firSubmenu), 2 : (secItem, secValue, secSubmenu)}
                            self.i_navfunc[menuName] = {9 : "_smlib_%s_%s_%s" % (self.type, self.name, currentPage - 1), 10 : ""}

                            popup = popuplib.create(menuName)
                            popup.addlineAll(" ")

                            if self.type is "list":
                                popup.addline(_getMenu(firItem, first + 1, firUnder, firOption, firTag))
                                popup.addline(_getMenu(secItem, second + 1, secUnder, secOption, secTag))
                                if self.i_multilang:
                                    popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9, True))
                                    popup.addline(_getMenu(self.i_menulang["_smlib_exit"], 0))
                                else:
                                    popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9, True))
                                    popup.addline(_getMenu(self.i_menulang["_smlib_exit"][self.defaultlang], 0))

                            else:
                                popup.addline(_getMenu(firItem, 1, firUnder, firOption, firTag))
                                popup.addline(_getMenu(secItem, 2, secUnder, secOption, secTag))
                                if self.i_multilang:
                                    popup.addline(_getMenu(self.i_menulang["_smlib_back"], 9))
                                    popup.addline(_getMenu(self.i_menulang["_smlib_exit"], 0))
                                else:
                                    popup.addline(_getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9))
                                    popup.addline(_getMenu(self.i_menulang["_smlib_exit"][self.defaultlang], 0))
                            popup.menuselect = self.__selectBlock
                            self._title_()

    def _moditem_(self, item, newitem, value, options, inserttag, underline, withvalue, pageindex):
        """ modifie aa item by an other item and other value """
        if self._valid_(item) and self._valid_(newitem):
            index = self._index_(item, withvalue, pageindex)
            if index < 0: raise ValueError("Simplemenulib: cannot modifie item '%s' for %s %s, it does not exists" % (item, self.type, self.name))
            else:
                self.i_line[index][:5] = newitem, value, options, inserttag, underline
                if self.i_construct:
                    infItem, infValue, infOption, infTag, infUnder, infSubmenu, infName, infPage, infIndex, infList = self.i_line[index]
                    self.i_choice[infName][infIndex] = (newitem, value, infSubmenu)
                    if self.type is "list":
                        if self.i_multilang: popuplib.find(infName).modlineAll(infIndex + 1, _getMenu(newitem, infList + 1, infUnder, options, inserttag))
                        else: popuplib.find(infName).modline(infIndex + 1, _getMenu(newitem, infList + 1, infUnder, options, inserttag))
                    elif self.i_multilang: popuplib.find(infName).modlineAll(infIndex + 1, _getMenu(newitem, infIndex, infUnder, options, inserttag))
                    else: popuplib.find(infName).modline(infIndex + 1, _getMenu(newitem, infIndex, infUnder, options, inserttag))

    def _setitem_(self, item, newvalue, withvalue, pageindex):
        """ set a new value for an existing item """
        if self._valid_(item):
            index = self._index_(item, withvalue, pageindex)
            if index < 0: raise ValueError("Simplemenulib: cannot set value '%s' of item %s for %s %s, it does not exists" % (newvalue, item, self.type, self.name))
            else:
                self.i_line[index][1] = newvalue
                if self.i_construct:
                    infItem, infValue, infOption, infTag, infUnder, infSubmenu, infName, infPage, infIndex, infList = self.i_line[index]
                    self.i_choice[infName][infIndex] = (infItem, newvalue, infSubmenu)

    def _getModifiedItem_(self, item, withvalue, pageindex):
        """ get modified item with parameters 'options' and 'inserttag' """
        if self._valid_(item):
            index = self._index_(item, withvalue, pageindex)
            if index < 0: raise ValueError("Simplemenulib: cannot get modified item '%s' for %s %s, it does not exists" % (item, self.type, self.name))
            else:
                options, inserttag = self.i_line[index][2:4]
                if self.i_multilang: return _getLine(item, options, inserttag)
                else: return _getOption(item, options, inserttag)

    def _addReturnKey_(self):
        """ add return navigation at first page """
        if self.i_construct:
            name = "_smlib_%s_%s_1" % (self.type, self.name)
            if not self.i_navfunc[name].has_key(9):
                idxItem = _getItem(1, len(self.i_page), len(self.i_line)) + 1
                if self.i_navfunc[name].has_key(8): idxItem += 1
                if self.type is "list": popuplib.find(name).insline(idxItem, _getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9, True))
                else: popuplib.find(name).insline(idxItem, _getMenu(self.i_menulang["_smlib_back"][self.defaultlang], 9))
            self.i_navfunc[name][9] = "" if self.i_addReturnKey is True else self.i_addReturnKey

    def _delReturnKey_(self):
        """ delete return navigation at first page """
        self.i_addReturnKey = False
        if self.i_construct:
            name = "_smlib_%s_%s_1" % (self.type, self.name)
            if self.i_navfunc[name].has_key(9):
                idxItem = _getItem(1, len(self.i_page), len(self.i_line)) + 1
                if self.i_navfunc[name].has_key(8): idxItem += 1
                del self.i_navfunc[name][9]
                popuplib.find(name).dellineAll(idxItem)

    def _getValidUseridList_(self, users):
        """ get and check valid userid list """
        if isinstance(users, str):
            if users.startswith("#"): users = playerlib.getUseridList(users)
            else:
                try: users = [es.getuserid(users)]
                except ValueError: es.dbgmsg(0, "simplemenulib: parameter 'users' must be a list, a tupple, a single userid or a playerlib filter")
        elif isinstance(users, int): users = (users,)
        else:
            try: users = map(es.getuserid, users)
            except TypeError: es.dbgmsg(0, "simplemenulib: parameter 'users' must be a list, a tupple, a single userid or a playerlib filter")
        return [userid for userid in users if self._exists_("isValidId", userid)]




#####################################
# SIMPLEMENULIB BASE

class SimplemenulibBase(SimplemenulibBuilder):
    """
        ● SimplemenulibBase (mutual methodes for SimplelibMenu, SimplelibVote and SimplemenuList class)
            ▪ Methode
                • build()
                • delete()
                • pagecount()
                • itemcount()
                • addReturnKey()
                • delReturnKey()
                • pageexists(<page>)
                • pageview(<userid>)
                • addlist(<listname>)
                • loadlang(<filepath>)
                • close(<users>, [page])
                • unsend(<users>, [page])
                • timeout([mode], [time])
                • popupreturn(<popupname>)
                • isqueued(<userid>, [page])
                • itempage(<item>, [withvalue])
                • itemvalue(<item>, [pageindex])
                • itemexists(<item>, [withvalue], [pageindex])
                • getModifiedItem(<item>, [withvalue], [pageindex])
                • simplemenureturn(<simplemenuname>, [page], [type])
                • subpopupmenu(<item>, <name>, [withvalue], [pageindex])
                • subsimplemenu(<item>, <name>, [page], [type], [withvalue], [pageindex])
    """

    def __init__(self, type, name):
        SimplemenulibBuilder.__init__(self, type, name)
        self.defaultlang = "en"
        self.i_timeout = ()

    def build(self):
        """ build construction """
        self._build_()

    def delete(self):
        """ delete menu, vote or list itself """
        delete(self.name, self.type)

    def update(self, users, page = 0):
        """ update player's menu """
        if not self.i_construct: es.dbgmsg(1, "Simplemenulib: %s '%s' has not been sended yet" % (self.type, self.name))
        try:
            page = int(page)
            users = self._getValidUseridList_(users)
            for userid in users:
                if not page:
                    for page in self.i_page: popuplib.find(page).update(userid)
                elif self._exists_(value = page): popuplib.find(self.i_page[page - 1]).update(userid)
                else: es.dbgmsg(0, "Simplemenulib: cannot find page '%s' for %s '%s'" % (page, self.type, self.name))
        except ValueError: es.dbgmsg(0, "Simplemenulib: parameter 'page' must be numerical or a numerical string" % (page, self.type, self.name))

    def close(self, users, page = 0):
        """ close player's menu """
        if not self.i_construct: es.dbgmsg(1, "Simplemenulib: %s '%s' has not been sended yet" % (self.type, self.name))
        try:
            page = int(page)
            users = self._getValidUseridList_(users)
            for userid in users:
                try: simplemenuuser[userid].remPopup(self, False)
                except KeyError: pass
                if not page:
                    for page in self.i_page: popuplib.close(page, userid)
                elif self._exists_(value = page): popuplib.close(self.i_page[page - 1], userid)
                else: es.dbgmsg(0, "Simplemenulib: cannot find page '%s' for %s '%s'" % (page, self.type, self.name))
        except ValueError: es.dbgmsg(0, "Simplemenulib: parameter 'page' must be numerical or a numerical string" % (page, self.type, self.name))

    def unsend(self, users, page = 0):
        """ unsend player's menu """
        if not self.i_construct: es.dbgmsg(1, "Simplemenulib: %s '%s' has not been sended yet" % (self.type, self.name))
        try:
            page = int(page)
            users = self._getValidUseridList_(users)
            for userid in users:
                try: simplemenuuser[userid].remPopup(self, False)
                except KeyError: pass
                if not page:
                    for page in self.i_page: popuplib.unsendname(page, users)
                elif self._exists_(value = page): popuplib.unsendname(self.i_page[page - 1], users)
                else: es.dbgmsg(0, "Simplemenulib: cannot find page '%s' for %s '%s'" % (page, self.type, self.name))
        except ValueError: es.dbgmsg(0, "Simplemenulib: parameter 'page' must be numerical or a numerical string" % (page, self.type, self.name))

    def timeout(self, mode = "view", time = 0):
        """ set send/view timeout """
        try:
            time = abs(int(time))
            if mode is "view" or mode is "send":
                self.i_timeout = (mode, time)
                if self.i_construct:
                    for page in self.i_page: popuplib.find(page).timeout(mode, time)
            else: raise ValueError("Simplemenulib: timeout mode must be 'send' or 'view'")
        except ValueError: "Simplemenulib: time for %s %s must be numerical or a numerical string" % (self.type, self.name)

    def pagecount(self):
        """ get count of page from vote or vote """
        return self._count_()

    def pageexists(self, page):
        """ find if a page exists """
        return self._exists_(value = page)

    def pageview(self, userid):
        """ get player page is viewing """
        page = popuplib.active(userid)["name"]
        if page in self.i_page: return self.i_page.index(page) + 1
        else: return 0

    def itemexists(self, item, withvalue = None, pageindex = ()):
        """ find if choice exists """
        item = self._item_(item)
        if self._valid_(item):
            if self._index_(item, withvalue, pageindex) > -1: return True
            else: return False

    def itemvalue(self, item, pageindex = ()):
        """ find value of a choice """
        item = self._item_(item)
        if self._valid_(item):
            idxItem = self._index_(item, pageindex = pageindex)
            if idxItem > -1: return self.i_line[idxItem][1]
            else: return ""

    def itemcount(self):
        """ get count of choice"""
        return len(self.i_line)

    def itempage(self, item, withvalue = None):
        """ get count of choice"""
        return self._page_(self._item_(item), withvalue)

    def addlist(self, listname):
        """ add menu or vote in a list for a global deleting """
        addlist(listname, self.name, self.type)

    def isqueued(self, userid, page = 0):
        """ find if a page of menu or vote is queued to a player """
        try: int(page)
        except ValueError: "Simplemenulib: page '%s' for %s '%s' must be numerical or a numerical string" % (page, self.type, self.name)
        if not page:
            isqueued = {}
            if not self.i_construct:
                for pnumb in xrange(1, self._count_() + 1): isqueued[pnumb] = 0
            else:
                ipage = 0
                for pname in self.i_page:
                    ipage += 1
                    isqueued[ipage] = popuplib.isqueued(pname, userid)
            return isqueued
        elif not self.i_construct: return 0
        elif self._exists_(value = page): return popuplib.isqueued(self.i_page[page - 1], userid)

    def loadlang(self, filepath):
        """ init language file for menu, vote or list """
        try:
            for section, lang in langlib.Strings("%s/%s" % (simplemenupath, filepath)).items(): self.i_menulang[section] = lang
            self.i_loadlang = True
        except: self.i_loadlang = False

    def subpopupmenu(self, item, name, withvalue = None, pageindex = ()):
        """ send a other popup when specified item is selected """
        item = self._item_(item)
        if self._valid_(item):
            index = self._index_(item, withvalue, pageindex)
            if index < 0: raise ValueError("Simplemenulib: cannot find item '%s' for %s '%s', it does not exists" % (item, self.type, self.name))
            else:
                self.i_line[index][5] = name
                if self.i_construct:
                    infItem, infValue, infOption, infTag, infUnder, infSubmenu, infName, infPage, infIndex, infList = self.i_line[index]
                    self.i_choice[infName][infIndex] = (infItem, infValue, infSubmenu)

    def subsimplemenu(self, item, name, page = 1, type = None, withvalue = None, pageindex = ()):
        """ send an other simplemenu when specified item is selected """
        item = self._item_(item)
        if self._valid_(item):
            index = self._index_(item, withvalue, pageindex)
            if index < 0: raise ValueError("Simplemenulib: cannot find item '%s' for %s '%s', it does not exists" % (item, self.type, self.name))
            else:
                try: self.i_line[index][5] = (name, int(page), type)
                except ValueError: "Simplemenulib: page '%s' for %s '%s' must be numerical or a numerical string" % (page, self.type, self.name)
                if self.i_construct:
                    infItem, infValue, infOption, infTag, infUnder, infSubmenu, infName, infPage, infIndex, infList = self.i_line[index]
                    self.i_choice[infName][infIndex] = (infItem, infValue, infSubmenu)

    def popupreturn(self, popupname):
        """ set a popup for return function """
        self.i_addReturnKey = popupname if popupname else False
        if self.i_construct:
            if self.i_addReturnKey: self._addReturnKey_()
            else: self._delReturnKey_()

    def simplemenureturn(self, simplemenuname, page = 1, type = None):
        """ set an other simplemenu for return function """
        try: self.i_addReturnKey = (simplemenuname, int(page), type) if simplemenuname else False
        except ValueError: "Simplemenulib: page '%s' for %s '%s' must be numerical or a numerical string" % (page, self.type, self.name)
        if self.i_construct:
            if self.i_addReturnKey: self._addReturnKey_()
            else: self._delReturnKey_()

    def addReturnKey(self):
        """ add return key in first page from menu or vote """
        self.i_addReturnKey = True
        self._addReturnKey_()

    def delReturnKey(self):
        """ delete return key in first page from menu or vote """
        self._delReturnKey_()

    def getModifiedItem(self, item, withvalue = None, pageindex = ()):
        """ get modified choice with parameters 'options' and 'inserttag' """
        return self._getModifiedItem_(self._item_(item), withvalue, pageindex)




#####################################
# SIMPLEMENULIB MENU

class SimplemenulibMenu(SimplemenulibBase):
    """
        ● SimplemenulibMenu, work with menu construction
            ▪ Methode
                • send(<users>, [page], [prio])
                • title(<title>, [options], [showpage])
                • delchoice(<choice>, [withvalue], [pageindex])
                • setchoice(<choice>, [newvalue], [withvalue], [pageindex])
                • addchoice(<choice>, [value], [options], [inserttag], [underline])
                • inschoice(<choice>, <newchoice>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])
                • modchoice(<choice>, <newchoice>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])

            ▪ Attribute
                → blockselect = "block"     // block or definition called when player select a choice from a menu
                → blockselectic = "block"   // block or definition called when player select an invalid choice from a menu
                → blockselectnc = "block"   // block or definition called when player select a navigation choice from a menu
    """

    def __init__(self, menuname):
        SimplemenulibBase.__init__(self, "menu", menuname)
        self.blockselect = ""
        self.blockselectic = ""
        self.blockselectnc = ""

    def title(self, title, options = {}, showpage = True):
        """ set title of simplemenu """
        title = self._item_(title)
        if self._valid_(title):
            self.i_showpage = showpage
            if not self.i_multilang: self.i_title = _getOption(title, options)
            else:
                self.i_title = {}
                for lang, string in title.items(): self.i_title[lang] = _getOption(string, options)
            if self.i_construct: self._title_()

    def delchoice(self, choice, withvalue = None, pageindex = ()):
        """ delete a choice of the simplemenu """
        self._delitem_(self._item_(choice), withvalue, pageindex)

    def addchoice(self, choice, value = "", options = {}, inserttag = "", underline = True):
        """ add choice to the simplemenu """
        self._additem_(self._item_(choice), value, options, inserttag, underline)

    def setchoice(self, choice, newvalue = "", withvalue = None, pageindex = ()):
        """ set a new value for an existing choice of the simplemenu """
        self._setitem_(self._item_(choice), newvalue, withvalue, pageindex)

    def inschoice(self, choice, newchoice, value = "", options = {}, inserttag = "", underline = True, withvalue = None, pageindex = ()):
        """ insert a choice after an other choice of the simplemenu """
        self._insitem_(self._item_(choice), self._item_(newchoice), value, options, inserttag, underline, withvalue, pageindex)

    def modchoice(self, choice, newchoice, value = "", options = {}, inserttag = "", underline = True, withvalue = None, pageindex = ()):
        """ modifie a choice by an other choice and other value of the simplemenu """
        self._moditem_(self._item_(choice), self._item_(newchoice), value, options, inserttag, underline, withvalue, pageindex)

    def send(self, users, page = 1, prio = False):
        """ send player menu """
        if not self.i_construct: self._build_()
        if self._exists_(value = page):
            page = self.i_page[int(page) - 1]
            for userid in self._getValidUseridList_(users):
                try: simplemenuuser[userid].setPopup(self, prio)
                except KeyError:
                    simplemenuuser[userid] = SimplemenulibUser(userid)
                    simplemenuuser[userid].setPopup(self, prio)
                popuplib.send(page, userid, prio)
        else: es.dbgmsg(0, "Simplemenulib: cannot find page '%s' for menu '%s'" % (page, self.type, self.name))




#####################################
# SIMPLEMENULIB VOTE

class VoteAnswer(object):
    """ store votes and compare them"""
    def __init__(self, answer, value, modif):
        self.answer = answer
        self.value = value
        self.modif = modif
        self.player = []
        self.count = 0

    def __add__(self, userid):
        if not userid in self.player:
            self.player.append(userid)
            self.count += 1

    def __sub__(self, userid):
        if userid in self.player:
            self.player.remove(userid)
            self.count -= 1

    def __cmp__(self, answer):
        return cmp(self.count, answer.count)

class SimplemenulibVote(SimplemenulibBase):
    """
        ● SimplemenulibVote, work with vote construction
            ▪ Methode
                • end()
                • stop()
                • disqualify(<users>)
                • question(<question>, [options], [showpage])
                • delanswer(<answer>, [withvalue], [pageindex])
                • submit([users], [time], [showhudstat], [prio])
                • setanswer(<answer>, [newvalue], [withvalue], [pageindex])
                • addanswer(<answer>, [value], [options], [inserttag], [underline])
                • insanswer(<answer>, <newanswer>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])
                • modanswer(<answer>, <newanswer>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])

            ▪ Attribute
                → blockendvote = "block"    // block or definition called when vote is ending
                → blocksubmit = "block"     // block or definition called when player select an answer from  a vote
                → blocksubmitic = "block"   // block or definition called when player select an invalid choice from a vote
                → blocksubmitnc = "block"   // block or definition called when player select a navigation choice from a vote

            ▪ Get Attribute
                - "showhud"                 // get if stats is showed in hud of players
                - "isrunning"               // get if vote is running
                - "timeleft"                // get time left before end of vote
                - "votecount"               // get count of vote submited in vote
                - "participents"            // get count of participents
                - "winninganswer"           // get answer, value, count and modified answer info from winning answer
                - "winningplayers"          // get userid list from winning answer
                - "answersvote"             // get answer, value, count and modified answer info from all voted answers
                - "playersvote"             // get userid dictionnary with answer, value, count and modified answer
    """

    def __init__(self, votename):
        SimplemenulibBase.__init__(self, "vote", votename)
        self.thread = "_smlib_%s" % votename
        self.votehud = True
        self.voterun = False
        self.voteend = 0
        self.votetime = 0
        self.voteadd = 0
        self.votecast = []
        self.voteplayer = {}
        self.votehudans = None
        self.blockendvote = ""
        self.blocksubmit = ""
        self.blocksubmitic = ""
        self.blocksubmitnc = ""

    def __getitem__(self, info):
        """ get information from vote """
        if info is "showhud": return self.votehud
        elif info is "isrunning": return self.voterun
        elif info is "timeleft": return self.voteend
        elif info is "votecount": return self.voteadd
        elif info is "useridlist": return self.voteplayer.keys()
        elif info is "participents": return len(self.voteplayer)
        elif info is "winninganswer":
            if not self.votecast: return {}
            else:
                winninganswer = self.votecast[0]
                return {"answer" : winninganswer.answer, "value" :  winninganswer.value, "count" : winninganswer.count, "modified" : winninganswer.modif}
        elif info is "winningplayers":
            if not self.votecast: return []
            else: return self.votecast[0].player[:]
        elif info is "answersvote":
            if not self.votecast: return {}
            else:
                answersvote = {}
                for position in xrange(1, len(self.votecast) + 1):
                    answer = self.votecast[position - 1]
                    answersvote[position] = {"answer" : answer.answer, "value" :  answer.value, "count" : answer.count, "modified" : answer.modif}
                return answersvote
        elif info is "playersvote":
            if not self.voteplayer: return {}
            else:
                playersvote = {}
                for userid in self.voteplayer:
                    try:
                        answer = self.voteplayer[userid]
                        if answer is not None: playersvote[userid] = {"answer" : answer.answer, "value" : answer.value, "count" : answer.count, "modified" : answer.modif}
                    except KeyError: pass
                return playersvote
        raise KeyError, "simplemenulib: cannot get key '%s' for vote '%s', it does not exists" % (info, self.name)

    def _hud(self):
        """ create and send message to all player's hud"""
        message = {}
        keymsg = "_smlib_hudrun" if self.votetime else "_smlib_hudany"
        if self.i_multilang:
            for lang, question in self.i_title.items():
                if self.voterun:
                    try:
                        message[lang] = _getOption(self.i_menulang[keymsg][lang], {
                            "$question" : question, "$second" : self.voteend, "$hasvoted" : self.voteadd, "$participents": len(self.voteplayer)})
                    except KeyError:
                        message[lang] = _getOption(self.i_menulang[keymsg][self.defaultlang], {
                            "$question" : question, "$second" : self.voteend, "$hasvoted" : self.voteadd, "$participents": len(self.voteplayer)})

                    if self.votecast:
                        count = len(self.votecast)
                        message[lang] += "\n "
                        for answer in xrange(0, 3 if count > 2 else count):
                            votestat = self.votecast[answer]
                            try:
                                message[lang] += "\n%s" % _getOption(self.i_menulang["_smlib_hudadd"][lang], {
                                    "$position" : answer + 1, "$votes" : votestat.count, "$answer" : votestat.modif[lang]})
                            except KeyError:
                                message[lang] += "\n%s" % _getOption(self.i_menulang["_smlib_hudadd"][self.defaultlang], {
                                    "$position" : answer + 1, "$votes" : votestat.count, "$answer" : votestat.modif[self.defaultlang]})

                elif self.votecast:
                    try:
                        votestat = self.votehudans
                        message[lang] = _getOption(self.i_menulang["_smlib_hudend"][lang], {"$question" : question, "$answer" : votestat.modif[lang]})
                    except KeyError:
                        votestat = self.votehudans
                        message[lang]= _getOption(self.i_menulang["_smlib_hudend"][self.defaultlang], {"$question" : question, "$answer" : votestat.modif[self.defaultlang]})

        else:
            if self.voterun:
                message = _getOption(self.i_menulang[keymsg][self.defaultlang], {
                    "$question" : self.i_title, "$second" : self.voteend, "$hasvoted" : self.voteadd, "$participents": len(self.voteplayer)})
                if self.votecast:
                    count = len(self.votecast)
                    message += "\n "
                    for answer in xrange(0, 3 if count > 2 else count):
                        votestat = self.votecast[answer]
                        message += "\n%s" % _getOption(self.i_menulang["_smlib_hudadd"][self.defaultlang], {
                            "$position" : answer + 1, "$votes" : votestat.count, "$answer" : votestat.modif})

            elif self.votecast:
                votestat = self.votehudans
                message = _getOption(self.i_menulang["_smlib_hudend"][self.defaultlang], {"$question" : self.i_title, "$answer" : votestat.modif})
        for userid in self.voteplayer: simplemenuuser[userid].hudPopup(self, message)

    def _ticker(self):
        """ timer's vote. """
        if self.votetime:
            if self.voteend:
                self.voteend -= 1
                if self.votehud: self._hud()
                gamethread.delayedname(1, self.thread, self._ticker)
            elif self.voterun: self.end()
        elif self.votehud:
            self._hud()
            gamethread.delayedname(5, self.thread, self._ticker)

    def _voteIsRecorded(self, answer, value):
        """ get if the vote is allready recorded """
        for vote in self.votecast:
            if vote.answer == answer and vote.value == value: return vote
        return None

    def _simulatePlayerVote(self, userid, answer, value):
        """
            scripters helping methode: simulate a player vote.
            should be used with bot userid...
            be carefull with this.
        """
        answer = self._item_(answer)
        vote = self._voteIsRecorded(answer, value)
        if vote is not None: vote + userid
        else:
            vote = VoteAnswer(answer, value, self.getModifiedItem(answer, value))
            vote + userid
            self.votecast.append(vote)

        self.voteplayer[userid] = vote
        simplemenuuser[userid] = SimplemenulibUser(userid)
        simplemenuuser[userid].setPopup(self, False)
        self.votecast.sort(reverse = True)
        self.voteadd += 1
        self._hud()

    def question(self, question, options = {}, showpage = True):
        """ set question of vote """
        question = self._item_(question)
        if self._valid_(question):
            self.i_showpage = showpage
            if not self.i_multilang: self.i_title = _getOption(question, options)
            else:
                self.i_title = {}
                for lang, string in question.items(): self.i_title[lang] = _getOption(string, options)
            if self.i_construct: self._title_()

    def delanswer(self, answer, withvalue = None, pageindex = ()):
        """ delete answer from vote """
        self._delitem_(self._item_(answer), withvalue, pageindex)

    def addanswer(self, answer, value = "", options = {}, inserttag = "", underline = True):
        """ add answer from vote """
        self._additem_(self._item_(answer), value, options, inserttag, underline)

    def setanswer(self, answer, newvalue = "", withvalue = None, pageindex = ()):
        """ set a new value for an existing answer from vote """
        self._setitem_(self._item_(answer), newvalue, withvalue, pageindex)

    def insanswer(self, answer, newanswer, value = "", options = {}, inserttag = "", underline = True, withvalue = None, pageindex = ()):
        """ insert an answer after an other answer from vote """
        self._insitem_(self._item_(answer), self._item_(newanswer), value, options, inserttag, underline, withvalue, pageindex)

    def modanswer(self, answer, newanswer, value = "", options = {}, inserttag = "", underline = True, withvalue = None, pageindex = ()):
        """ modifie aanswer by an other answer and other value from vote"""
        self._moditem_(self._item_(answer), self._item_(newanswer), value, options, inserttag, underline, withvalue, pageindex)

    def submit(self, users = [], time = 30, page = 1, showhudstat = True, prio = False):
        self.votehud = showhudstat
        if not users: players = playerlib.getUseridList("#human")
        else: players = self._getValidUseridList_(users)
        if not players: es.dbgmsg(0, "simplemenulib: parametre 'users' must be a list, a tupple or a single valid userid")
        else:

            if self.voterun:
                for userid in players:
                    try:
                        simplemenuuser[userid].remPopup(self)
                        self.close(userid)
                    except KeyError:
                        simplemenuuser[userid] = SimplemenulibUser(userid)
                        self.voteplayer[userid] = None
                simplemenuuser[userid].setPopup(self, prio)
                self.votecast.sort(reverse = True)

            else:
                self.voteadd = 0
                self.votecast = []
                self.voterun = True
                self.voteplayer = {}
                self.voteend = abs(int(time))
                self.votetime = self.voteend

                if not self.i_construct: self._build_()
                try: gamethread.cancelDelayed(self.thread)
                except: pass
                for userid in players:
                    self.voteplayer[userid] = None
                    try: simplemenuuser[userid].setPopup(self, prio)
                    except KeyError:
                        simplemenuuser[userid] = SimplemenulibUser(userid)
                        simplemenuuser[userid].setPopup(self, prio)
                gamethread.delayed(1, self._ticker)

            if self._exists_(value = page): popuplib.send(self.i_page[int(page) - 1], players, prio)
            else: es.dbgmsg(0, "Simplemenulib: cannot find page '%s' for vote '%s'" % (page, self.name))
            if self.votehud: self._hud()

    def end(self):
        gamethread.cancelDelayed(self.thread)
        if self.voterun:
            if self.votecast:
                self.votecast.sort(reverse = True)
                first = self.votecast[0]
                tie = [vote for vote in self.votecast if vote.count == first.count]
                vote = self.votehudans = random.choice(tie)
                answer, value, votes, total, players = vote.answer, vote.value, vote.count, self.voteadd, len(self.voteplayer)

            else: answer, value, votes, total, players = "", "", 0, 0, len(self.voteplayer)
            try: percent = int(float(votes) / self.voteadd * 100)
            except ZeroDivisionError: percent = 0
            self.voterun = False

            if self.votehud: self._hud()
            for userid in self.voteplayer:
                user = simplemenuuser[userid]
                user.remPopup(self)
                self.unsend(userid)

            self.voteadd = 0
            self.votetotal = 0
            self.votecast = []
            self.voteplayer = {}

            if callable(self.blockendvote):
                try: self.blockendvote(answer, value, votes, total, players, percent, self.name)
                except:
                    es.dbgmsg(0, "Simplemenulib found invalid function '%s' for vote '%s'" % (self.blockendvote.__name__, self.name))
                    es.dbgmsg(0, "Simplemenulib callback function blockendvote must accept seven parameters")
        else: es.dbgmsg(1, "simplemenulib: the vote '%s' was not started" % self.name)

    def disqualify(self, users):
        if self.voterun:
            players = self._getValidUseridList_(users)
            if not players: es.dbgmsg(0, "simplemenulib: parameter 'users' must be a list, a tupple or a single valid userid")
            else:
                for userid in players:
                    try:
                        player = simplemenuuser[userid]
                        player.hudPopup(self, False)
                        player.remPopup(self)
                        self.unsend(userid)
                        del self.voteplayer[userid]
                    except KeyError: pass
                if self.voteadd >= len(self.voteplayer): self.end()
        else: es.dbgmsg(1, "simplemenulib: the vote '%s' was not started" % self.name)

    def stop(self):
        try: gamethread.cancelDelayed(self.thread)
        except: pass
        if self.voterun:
            for userid in self.voteplayer:
                self.close(userid)
                simplemenuuser[userid].remPopup(self)
            self.votetotal, self.voteplayer, self.votecast, self.voterun = 0, {}, [], False
        else: es.dbgmsg(1, "simplemenulib: the vote '%s' was not started" % self.name)




#####################################
# SIMPLEMENULIB LIST

class SimplemenulibList(SimplemenulibBase):
    """
        ● SimplemenulibList
            ▪ Methode
                • display(<users>, [page], [prio])
                • title(<title>, [options], [showpage])
                • delitem(<item>, [withvalue], [pageindex])
                • setitem(<item>, [newvalue], [withvalue], [pageindex])
                • additem(<item>, [value], [options], [inserttag], [underline])
                • insitem(<item>, <newitem>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])
                • moditem(<item>, <newitem>, [value], [options], [inserttag], [underline], [withvalue], [pageindex])

            ▪ Attribute
                → blocklist = "block"         // block or definition called when player select an item from a list
                → blocklistic = "block"       // block or definition called when player select an invalid choice from a list
                → blocklistnc = "block"       // block or definition called when player select a navigation choice from a list
    """

    def __init__(self, listname, listitem = []):
        SimplemenulibBase.__init__(self, "list", listname)
        for item in listitem: self.additem(*item)
        self.blocklist = ""
        self.blocklistic = ""
        self.blocklistnc = ""

    def title(self, title, options = {}, showpage = True):
        """ set question of list menu """
        title = self._item_(title)
        if self._valid_(title):
            self.i_showpage = showpage
            if not self.i_multilang: self.i_title = _getOption(title, options)
            else:
                self.i_title = {}
                for lang, string in title.items(): self.i_title[lang] = _getOption(string, options)
            if self.i_construct: self._title_()

    def delitem(self, item, withvalue = None, pageindex = ()):
        """ delete item from list """
        self._delitem_(self._item_(item), withvalue, pageindex)

    def additem(self, item, value = "", options = {}, inserttag = "", underline = False):
        """ add item from list """
        self._additem_(self._item_(item), value, options, inserttag, underline)

    def setitem(self, item, newvalue = "", withvalue = None, pageindex = ()):
        """ set a new value for an existing item from list """
        self._setitem_(self._item_(item), newvalue, withvalue, pageindex)

    def insitem(self, item, newitem, value = "", options = {}, inserttag = "", underline = False, withvalue = None, pageindex = ()):
        """ insert an item after an other item from list """
        self._insitem_(self._item_(item), self._item_(newitem), value, options, inserttag, underline, withvalue, pageindex)

    def moditem(self, item, newitem, value = "", options = {}, inserttag = "", underline = False, withvalue = None, pageindex = ()):
        """ modifie an item by an other item and other value from list """
        self._moditem_(self._item_(item), self._item_(newitem), value, options, inserttag, underline, withvalue, pageindex)

    def display(self, users, page = 1, prio = False):
        if not self.i_construct: self._build_()
        if self._exists_(value = page):
            page = self.i_page[int(page) - 1]
            for userid in self._getValidUseridList_(users):
                try: simplemenuuser[userid].setPopup(self, prio)
                except KeyError:
                    simplemenuuser[userid] = SimplemenulibUser(userid)
                    simplemenuuser[userid].setPopup(self, prio)
                popuplib.send(page, userid, prio)
        else: es.dbgmsg(0, "Simplemenulib: cannot find page '%s' for list '%s'" % (page, self.name))




#####################################
# SIMPLEMENULIB USER

class SimplemenulibUser(object):
    """ makes link from player's menu(s), vote(s) and list(s) """
    def __init__(self, userid):
        userlang = es.getclientvar(userid, "cl_language")
        self.language  = langlib.getLangAbbreviation("english" if userlang is None else userlang)
        self.userid = userid
        self.handle = []
        self.hudmsg = []

    def delPopup(self):
        """ delete popups from player """
        remove = len(self.handle)
        while remove:
            remove -= 1
            self.remPopup(self.handle[remove], True, True)

    def remPopup(self, instance, answer = True, endvote = False):
        """ remove popup from player's queue """
        try:
            self.handle.remove(instance)
            if instance.type is "vote":
                if instance.voterun:
                    if answer:
                        voteplayer = instance.voteplayer[self.userid]
                        if voteplayer is not None: voteplayer - self.userid
                        del instance.voteplayer[self.userid]
                    if endvote:
                        participents = len(instance.voteplayer)
                        if instance.voteadd >= participents:
                            if participents: instance.end()
                            else: instance.stop()
                elif instance in self.hudmsg: self.hudmsg.remove(instance)
        except: pass

    def setPopup(self, instance, prio):
        """ set popup from player's queue """
        if not instance in self.handle:
            if prio: self.handle.insert(0, instance)
            else: self.handle.append(instance)
            if instance.type is "vote":
                if prio: self.hudmsg.insert(0, instance)
                else: self.hudmsg.append(instance)

        elif prio:
            self.handle.remove(instance)
            self.handle.insert(0, instance)
            if instance.type is "vote":
                self.hudmsg.remove(instance)
                self.hudmsg.insert(0, instance)

    def hudPopup(self, instance, message = True):
        """ display hud from player's queue """
        try:
            if instance == self.hudmsg[0] and self.userid > 1:
                if message:
                    if instance.i_multilang:
                        try: usermsg = message[self.language]
                        except KeyError: usermsg = message[instance.i_defaultlang]
                    else: usermsg = message

                    es.usermsg('create', '_smlib_votehud', 'HintText')
                    es.usermsg('write', 'bool', '_smlib_votehud', 0)
                    es.usermsg("write", "string", "_smlib_votehud", usermsg)
                    es.usermsg("send", "_smlib_votehud", self.userid, 0)

                else:
                    es.usermsg("create", "_smlib_votehud", "ResetHUD")
                    es.usermsg("write", "byte", "_smlib_votehud", -1)
                    es.usermsg("send", "_smlib_votehud", self.userid, 1)
                es.usermsg("delete", "_smlib_votehud")
        except: pass




#####################################
# SIMPLEMENULIB FUNCTION
"""
    ■ simplemenulib function

        ▪ Global function
            • type(<name>)                                                  // get the type of a simplemenulib construction, can return ['menu', 'vote', 'list']
            • active(<userid>)                                              // get information from a menu or a vote that player is wiewing, type can be 'menu', 'vote' or 'list'
            • find(<name>, [type])                                          // return the instance of a menu or a vote, type can be 'menu', 'vote' or 'list'
            • exists(<name>, [type])                                        // check if a menu or a vote exists, type can be 'menu', 'vote' or 'list'
            • delete(<name>, [type])                                        // delete an existing menu or vote, type can be 'menu', 'vote' or 'list'
            • close(<users>, <name>, [page], [type])                        // close a menu that player is viewing, type can be 'menu', 'vote' or 'list'
            • unsend(<users>, <name>, [page], [type])                       // unsend a menu that player is wiewing, type can be 'menu', 'vote' or 'list'
            • isqueued(<userid>, <name>, [page], [type])                    // find if a page of a menu or vote is queued to a player, type can be 'menu' or 'vote'
            • addlist(<list name>, <name>, [type])                          // add a menu and/or a vote in a list for a global deleting, type can be 'menu', 'vote' or 'list'
            • getlist(<list name>)                                          // get name of all menu and/or vote stored in the list
            • dellist(<list name>)                                          // delete all menu and/or vote stored in the list
"""

def type(name):
    """ get the type(s) of a simplemenulib construction, can return ['menu', 'vote', 'list'] """
    return _getType(name)

def exists(name, type = None):
    """ check if a menu or a vote exists, type can be 'menu' or 'vote' """
    name = str(name)
    if type is None and not len(_getType(name)): return False
    elif type is "menu" and not simplemenumenu.has_key(name): return False
    elif type is "vote" and not simplemenuvote.has_key(name): return False
    elif type is "list" and not simplemenulist.has_key(name): return False
    return True

def find(name, type = None):
    """ return the instance of a menu or a vote, type can be 'menu', 'vote' or 'list' """
    name = str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(0, "Simplemenulib: cannot find menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: raise ValueError("Simplemenulib: cannot find '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if type is "menu": return simplemenumenu[name]
    elif type is "vote": return simplemenuvote[name]
    elif type is "list": return simplemenulist[name]

def update(users, name, page = 0, type = None):
    """
        users can be a list, tupple or a single valid userid
        update a menu, vote or list that player is viewing
    """
    name = str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(0, "Simplemenulib: cannot find menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: raise ValueError("Simplemenulib: cannot update '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if type is "menu": simplemenumenu[name].update(users, page)
    elif type is "vote": simplemenuvote[name].update(users, page)
    elif type is "list": simplemenulist[name].update(users, page)

def close(users, name, page = 0, type = None):
    """
        users can be a list, tupple or a single valid userid
        close a menu, vote or list that player is viewing
    """
    name = str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(0, "Simplemenulib: cannot find menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: raise ValueError("Simplemenulib: cannot close '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if type is "menu": simplemenumenu[name].close(users, page)
    elif type is "vote": simplemenuvote[name].close(users, page)
    elif type is "list": simplemenulist[name].close(users, page)

def unsend(users, name, page = 0, type = None):
    """
        users can be a list, tupple or a single valid userid
        unsend a menu, vote or list that player is wiewing
        'menuselect10' command will be executed
    """
    name = str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(0, "Simplemenulib: cannot find menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: raise ValueError("Simplemenulib: cannot unsend '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if type is "menu": simplemenumenu[name].unsend(users, page)
    elif type is "vote": simplemenuvote[name].unsend(users, page)
    elif type is "list": simplemenulist[name].unsend(users, page)

def delete(name, type = None):
    """ delete an existing menu or vote, type can be 'menu' or 'vote' """
    name = str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(0, "Simplemenulib: cannot find menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: raise ValueError("Simplemenulib: cannot delete '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if type is "menu":
        try:
            menu = simplemenumenu[name]
            for userpopup in simplemenuuser.values(): userpopup.remPopup(menu)
            menu._delete_()
            del simplemenumenu[name]
        except KeyError: es.dbgmsg(0, "Simplemenulib: cannot delete menu '%s', it does not exist" % name)
    elif type is "vote":
        try:
            vote = simplemenuvote[name]
            if vote.voterun: vote.stop()
            for userpopup in simplemenuuser.values(): userpopup.remPopup(vote)
            vote._delete_()
            del simplemenuvote[name]
        except KeyError: es.dbgmsg(0, "Simplemenulib: cannot delete vote '%s', it does not exist" % name)
    elif type is "list":
        try:
            list = simplemenulist[name]
            for userpopup in simplemenuuser.values(): userpopup.remPopup(list)
            list._delete_()
            del simplemenulist[name]
        except KeyError: es.dbgmsg(0, "Simplemenulib: cannot delete list '%s', it does not exist" % name)

def isqueued(userid, name, page = 0, type = None):
    """
        find if a page of a menu or vote is queued to a player, type can be 'menu' or 'vote'
        if page isn't given, return a dictionnary like {# of page : # in queue}
    """
    name = str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(0, "Simplemenulib: cannot find menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: raise ValueError("Simplemenulib: cannot get queue's player of '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if type is "menu": return simplemenumenu[name].isqueued(userid, page)
    elif type is "vote": return simplemenuvote[name].isqueued(userid, page)
    elif type is "list": return simplemenulist[name].isqueued(userid, page)

def active(userid):
    """
        get the menu, the vote or the list popup active from a player
        return a dictionnary like {"name" : <name>, "page" : <page>, "count" : <page(s) sended>, "type" : <type of construction>}
    """
    try:
        userid = int(userid)
        try:
            active = simplemenuuser[userid]
            try:
                handle = active.handle[0]
                popup = popuplib.active(userid)
                page = popup["name"]
                if page in handle.i_page: return {"name" : handle.name, "page" : handle.i_page.index(page) + 1, "count" : popup["count"], "type" : handle.type}
                return {"name" : "", "page" : 0, "count" : 0, "type" : None}
            except IndexError: return {"name" : "", "page" : 0, "count" : 0, "type" : None}
        except KeyError: return {"name" : "", "page" : 0, "count" : 0, "type" : None}
    except ValueError: "simplemenulib: parameter 'userid' must be numerical or a numerical string"

def addlist(listname, name, type = None):
    """ add a menu and/or a vote in a list for a global deleting """
    listname, name = str(listname), str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(1, "Simplemenulib: cannot add to the list menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: es.dbgmsg(1, "Simplemenulib: cannot add to the list '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if not simplemenucast.has_key(listname): simplemenucast[listname] = set()
    simplemenucast[listname].add((name, type))

def remlist(listname, name, type = None):
    """ add a menu and/or a vote in a list for a global deleting """
    listname, name = str(listname), str(name)
    if type is None:
        type = _getType(name)
        if not type: es.dbgmsg(1, "Simplemenulib: cannot remove from the list menu, vote or list '%s', it does not exist" % name)
        elif len(type) == 1: type = type[0]
        else: raise es.dbgmsg(1, "Simplemenulib: cannot remove from the list '%s' because there are menu/vote/list constructions with same name, you have to precise the type" % name)
    if simplemenucast.has_key(listname):
        try: simplemenucast[listname].remove(name)
        except KeyError: es.dbgmsg(1, 'Simplemenulib: cannot remove %s "%s" from list "%s"' % (type, name, listname))

def dellist(listname):
    """ delete all menu and/or vote stored in the list """
    listname = str(listname)
    if simplemenucast.has_key(listname):
        for name, type in simplemenucast[listname]:
            if exists(name, type): delete(name, type)
            elif popuplib.exists(name): popuplib.delete(name)
        del simplemenucast[listname]

def getlist(listname):
    """
        get name of all menu, vote and/or list stored in the list
        return a list like ['name 1', 'name 2', etc...]
    """
    listname, getlist = str(listname), []
    if simplemenucast.has_key(listname):
        for name, type in simplemenucast[listname]: getlist.append(name)
    return getlist



"""
        ▪ Menu function
            • menu(<menu name>)                                         // create a menu
            • send(<users>, <menu name>, [page], [prio])                // send a menu to a player(s)
"""

def menu(menuname):
    """ create a menu"""
    name = str(menuname)
    if simplemenumenu.has_key(name): delete(name, "menu")
    simplemenumenu[name] = SimplemenulibMenu(name)
    return simplemenumenu[name]

def send(users, menuname, page = 1, prio = False):
    """
        send a menu to a player(s)
        users can be a list, tupple or a single userid
    """
    name = str(menuname)
    try: simplemenumenu[name].send(users, page, prio = False)
    except KeyError: "Simplemenulib: cannot find menu '%s', it does not exist" % name



"""
        ▪ Vote function
            • end(<votename>)                                               // end a vote
            • stop(<votename>)                                              // stop a vote
            • vote(<votename>)                                              // create a vote
            • info(<votename>, [attrib])                                    // get info from a vote
            • disqualify(<votename>, <users>)                               // disqualify a (group of) player from a vote
            • submit(<votename>, [users], [time], [showhudstat], [prio])    // submit a vote to a (group of) player
"""

def vote(votename):
    """ create a vote """
    name = str(votename)
    if simplemenuvote.has_key(name): delete(name, "vote")
    simplemenuvote[name] = SimplemenulibVote(name)
    return simplemenuvote[name]

def info(votename, attrib = None):
    """ get info from a vote """
    name = str(votename)
    try:
        if attrib is None:
            vote = simplemenuvote[name]
            return {
                "showhud" : vote["showhud"],
                "isrunning" : vote["isrunning"],
                "timeleft" : vote["timeleft"],
                "votecount" : vote["votecount"],
                "participents" : vote["participents"],
                "winninganswer" : vote["winninganswer"],
                "winningplayers" : vote["winningplayers"],
                "answersvote" : vote["answersvote"],
                "playersvote" : vote["playersvote"]}
        else: return simplemenuvote[name][str(attrib)]
    except KeyError: "Simplemenulib: cannot find vote '%s', it does not exist" % name

def stop(votename):
    """ stop a vote """
    name = str(votename)
    try: simplemenuvote[name].stop()
    except KeyError: "Simplemenulib: cannot find vote '%s', it does not exist" % name

def end(votename):
    """ finish a vote """
    name = str(votename)
    try: simplemenuvote[name].end()
    except KeyError: "Simplemenulib: cannot find vote '%s', it does not exist" % name

def disqualify(votename, users):
    """ disqualify player(s) from a vote """
    name = str(votename)
    try: simplemenuvote[name].disqualify(users)
    except KeyError: "Simplemenulib: cannot find vote '%s', it does not exist" % name

def submit(votename, users= [], time = 30, page = 1, showhudstat = True, prio = False):
    """ submit a vote """
    name = str(votename)
    try: simplemenuvote[name].submit(users, time, page, showhudstat, prio)
    except KeyError: "Simplemenulib: cannot find vote '%s', it does not exist" % name



"""
        ▪ List function
            • list(<listname>, [listitem])                                  // create a list (top10 style)
            • display(<listname>, <users>, [page], [prio])                  // display a list (top10 style)
"""

def list(listname, listitem = []):
    name = str(listname)
    if simplemenulist.has_key(name): delete(name, "list")
    simplemenulist[name] = SimplemenulibList(name, *listitem)
    return simplemenulist[name]

def display(users, listname, page = 1, prio = False):
    name = str(listname)
    try: simplemenulist[name].display(users, page, prio)
    except KeyError: "Simplemenulib: cannot find list '%s', it does not exist" % name




#####################################
# EVENTSCRIPTS EVENTS

def es_map_start(event_var):
    # clear players informations dictionnary at map start even if player_disconnect makes it
    simplemenuuser.clear()

def player_disconnect(event_var):
    """ delete player's vote and finish vote if he was the last to make a choice """
    try:
        userid = int(event_var["userid"])
        simplemenuuser[userid].delPopup()
        del simplemenuuser[userid]
    except: pass

# registering event for vote system
moduleImport = __import__(__name__)
es.addons.registerForEvent(moduleImport, "es_map_start", es_map_start)
es.addons.registerForEvent(moduleImport, "player_disconnect", player_disconnect)
